t / test-lib.shon commit Merge branch 'jk/maint-commit-check-committer-early' into maint-1.7.11 (9e0833c)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45# A call to "unset" with no arguments causes at least Solaris 10
  46# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  47# deriving from the command substitution clustered with the other
  48# ones.
  49unset VISUAL EMAIL LANGUAGE COLUMNS $(perl -e '
  50        my @env = keys %ENV;
  51        my $ok = join("|", qw(
  52                TRACE
  53                DEBUG
  54                USE_LOOKUP
  55                TEST
  56                .*_TEST
  57                PROVE
  58                VALGRIND
  59                PERF_AGGREGATING_LATER
  60        ));
  61        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  62        print join("\n", @vars);
  63')
  64GIT_AUTHOR_EMAIL=author@example.com
  65GIT_AUTHOR_NAME='A U Thor'
  66GIT_COMMITTER_EMAIL=committer@example.com
  67GIT_COMMITTER_NAME='C O Mitter'
  68GIT_MERGE_VERBOSITY=5
  69GIT_MERGE_AUTOEDIT=no
  70export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
  71export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  72export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  73export EDITOR
  74
  75# Protect ourselves from common misconfiguration to export
  76# CDPATH into the environment
  77unset CDPATH
  78
  79unset GREP_OPTIONS
  80
  81case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  82        1|2|true)
  83                echo "* warning: Some tests will not work if GIT_TRACE" \
  84                        "is set as to trace on STDERR ! *"
  85                echo "* warning: Please set GIT_TRACE to something" \
  86                        "other than 1, 2 or true ! *"
  87                ;;
  88esac
  89
  90# Convenience
  91#
  92# A regexp to match 5 and 40 hexdigits
  93_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  94_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  95
  96# Zero SHA-1
  97_z40=0000000000000000000000000000000000000000
  98
  99# Line feed
 100LF='
 101'
 102
 103export _x05 _x40 _z40 LF
 104
 105# Each test should start with something like this, after copyright notices:
 106#
 107# test_description='Description of this test...
 108# This test checks if command xyzzy does the right thing...
 109# '
 110# . ./test-lib.sh
 111[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 112                TERM=$ORIGINAL_TERM &&
 113                export TERM &&
 114                [ -t 1 ] &&
 115                tput bold >/dev/null 2>&1 &&
 116                tput setaf 1 >/dev/null 2>&1 &&
 117                tput sgr0 >/dev/null 2>&1
 118        ) &&
 119        color=t
 120
 121while test "$#" -ne 0
 122do
 123        case "$1" in
 124        -d|--d|--de|--deb|--debu|--debug)
 125                debug=t; shift ;;
 126        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 127                immediate=t; shift ;;
 128        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 129                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 130        -h|--h|--he|--hel|--help)
 131                help=t; shift ;;
 132        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 133                verbose=t; shift ;;
 134        -q|--q|--qu|--qui|--quie|--quiet)
 135                # Ignore --quiet under a TAP::Harness. Saying how many tests
 136                # passed without the ok/not ok details is always an error.
 137                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 138        --with-dashes)
 139                with_dashes=t; shift ;;
 140        --no-color)
 141                color=; shift ;;
 142        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 143                valgrind=t; verbose=t; shift ;;
 144        --tee)
 145                shift ;; # was handled already
 146        --root=*)
 147                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 148                shift ;;
 149        *)
 150                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 151        esac
 152done
 153
 154if test -n "$color"; then
 155        say_color () {
 156                (
 157                TERM=$ORIGINAL_TERM
 158                export TERM
 159                case "$1" in
 160                        error) tput bold; tput setaf 1;; # bold red
 161                        skip)  tput bold; tput setaf 2;; # bold green
 162                        pass)  tput setaf 2;;            # green
 163                        info)  tput setaf 3;;            # brown
 164                        *) test -n "$quiet" && return;;
 165                esac
 166                shift
 167                printf "%s" "$*"
 168                tput sgr0
 169                echo
 170                )
 171        }
 172else
 173        say_color() {
 174                test -z "$1" && test -n "$quiet" && return
 175                shift
 176                echo "$*"
 177        }
 178fi
 179
 180error () {
 181        say_color error "error: $*"
 182        GIT_EXIT_OK=t
 183        exit 1
 184}
 185
 186say () {
 187        say_color info "$*"
 188}
 189
 190test "${test_description}" != "" ||
 191error "Test script did not set test_description."
 192
 193if test "$help" = "t"
 194then
 195        echo "$test_description"
 196        exit 0
 197fi
 198
 199exec 5>&1
 200exec 6<&0
 201if test "$verbose" = "t"
 202then
 203        exec 4>&2 3>&1
 204else
 205        exec 4>/dev/null 3>/dev/null
 206fi
 207
 208test_failure=0
 209test_count=0
 210test_fixed=0
 211test_broken=0
 212test_success=0
 213
 214test_external_has_tap=0
 215
 216die () {
 217        code=$?
 218        if test -n "$GIT_EXIT_OK"
 219        then
 220                exit $code
 221        else
 222                echo >&5 "FATAL: Unexpected exit with code $code"
 223                exit 1
 224        fi
 225}
 226
 227GIT_EXIT_OK=
 228trap 'die' EXIT
 229
 230# The user-facing functions are loaded from a separate file so that
 231# test_perf subshells can have them too
 232. "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
 233
 234# You are not expected to call test_ok_ and test_failure_ directly, use
 235# the text_expect_* functions instead.
 236
 237test_ok_ () {
 238        test_success=$(($test_success + 1))
 239        say_color "" "ok $test_count - $@"
 240}
 241
 242test_failure_ () {
 243        test_failure=$(($test_failure + 1))
 244        say_color error "not ok - $test_count $1"
 245        shift
 246        echo "$@" | sed -e 's/^/#       /'
 247        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 248}
 249
 250test_known_broken_ok_ () {
 251        test_fixed=$(($test_fixed+1))
 252        say_color "" "ok $test_count - $@ # TODO known breakage"
 253}
 254
 255test_known_broken_failure_ () {
 256        test_broken=$(($test_broken+1))
 257        say_color skip "not ok $test_count - $@ # TODO known breakage"
 258}
 259
 260test_debug () {
 261        test "$debug" = "" || eval "$1"
 262}
 263
 264test_eval_ () {
 265        # This is a separate function because some tests use
 266        # "return" to end a test_expect_success block early.
 267        eval </dev/null >&3 2>&4 "$*"
 268}
 269
 270test_run_ () {
 271        test_cleanup=:
 272        expecting_failure=$2
 273        test_eval_ "$1"
 274        eval_ret=$?
 275
 276        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 277        then
 278                test_eval_ "$test_cleanup"
 279        fi
 280        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 281                echo ""
 282        fi
 283        return "$eval_ret"
 284}
 285
 286test_skip () {
 287        test_count=$(($test_count+1))
 288        to_skip=
 289        for skp in $GIT_SKIP_TESTS
 290        do
 291                case $this_test.$test_count in
 292                $skp)
 293                        to_skip=t
 294                        break
 295                esac
 296        done
 297        if test -z "$to_skip" && test -n "$test_prereq" &&
 298           ! test_have_prereq "$test_prereq"
 299        then
 300                to_skip=t
 301        fi
 302        case "$to_skip" in
 303        t)
 304                of_prereq=
 305                if test "$missing_prereq" != "$test_prereq"
 306                then
 307                        of_prereq=" of $test_prereq"
 308                fi
 309
 310                say_color skip >&3 "skipping test: $@"
 311                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 312                : true
 313                ;;
 314        *)
 315                false
 316                ;;
 317        esac
 318}
 319
 320# stub; perf-lib overrides it
 321test_at_end_hook_ () {
 322        :
 323}
 324
 325test_done () {
 326        GIT_EXIT_OK=t
 327
 328        if test -z "$HARNESS_ACTIVE"; then
 329                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 330                mkdir -p "$test_results_dir"
 331                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 332
 333                cat >>"$test_results_path" <<-EOF
 334                total $test_count
 335                success $test_success
 336                fixed $test_fixed
 337                broken $test_broken
 338                failed $test_failure
 339
 340                EOF
 341        fi
 342
 343        if test "$test_fixed" != 0
 344        then
 345                say_color pass "# fixed $test_fixed known breakage(s)"
 346        fi
 347        if test "$test_broken" != 0
 348        then
 349                say_color error "# still have $test_broken known breakage(s)"
 350                msg="remaining $(($test_count-$test_broken)) test(s)"
 351        else
 352                msg="$test_count test(s)"
 353        fi
 354        case "$test_failure" in
 355        0)
 356                # Maybe print SKIP message
 357                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 358
 359                if test $test_external_has_tap -eq 0; then
 360                        say_color pass "# passed all $msg"
 361                        say "1..$test_count$skip_all"
 362                fi
 363
 364                test -d "$remove_trash" &&
 365                cd "$(dirname "$remove_trash")" &&
 366                rm -rf "$(basename "$remove_trash")"
 367
 368                test_at_end_hook_
 369
 370                exit 0 ;;
 371
 372        *)
 373                if test $test_external_has_tap -eq 0; then
 374                        say_color error "# failed $test_failure among $msg"
 375                        say "1..$test_count"
 376                fi
 377
 378                exit 1 ;;
 379
 380        esac
 381}
 382
 383# Test the binaries we have just built.  The tests are kept in
 384# t/ subdirectory and are run in 'trash directory' subdirectory.
 385if test -z "$TEST_DIRECTORY"
 386then
 387        # We allow tests to override this, in case they want to run tests
 388        # outside of t/, e.g. for running tests on the test library
 389        # itself.
 390        TEST_DIRECTORY=$(pwd)
 391fi
 392if test -z "$TEST_OUTPUT_DIRECTORY"
 393then
 394        # Similarly, override this to store the test-results subdir
 395        # elsewhere
 396        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
 397fi
 398GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 399
 400if test -n "$valgrind"
 401then
 402        make_symlink () {
 403                test -h "$2" &&
 404                test "$1" = "$(readlink "$2")" || {
 405                        # be super paranoid
 406                        if mkdir "$2".lock
 407                        then
 408                                rm -f "$2" &&
 409                                ln -s "$1" "$2" &&
 410                                rm -r "$2".lock
 411                        else
 412                                while test -d "$2".lock
 413                                do
 414                                        say "Waiting for lock on $2."
 415                                        sleep 1
 416                                done
 417                        fi
 418                }
 419        }
 420
 421        make_valgrind_symlink () {
 422                # handle only executables, unless they are shell libraries that
 423                # need to be in the exec-path.  We will just use "#!" as a
 424                # guess for a shell-script, since we have no idea what the user
 425                # may have configured as the shell path.
 426                test -x "$1" ||
 427                test "#!" = "$(head -c 2 <"$1")" ||
 428                return;
 429
 430                base=$(basename "$1")
 431                symlink_target=$GIT_BUILD_DIR/$base
 432                # do not override scripts
 433                if test -x "$symlink_target" &&
 434                    test ! -d "$symlink_target" &&
 435                    test "#!" != "$(head -c 2 < "$symlink_target")"
 436                then
 437                        symlink_target=../valgrind.sh
 438                fi
 439                case "$base" in
 440                *.sh|*.perl)
 441                        symlink_target=../unprocessed-script
 442                esac
 443                # create the link, or replace it if it is out of date
 444                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 445        }
 446
 447        # override all git executables in TEST_DIRECTORY/..
 448        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 449        mkdir -p "$GIT_VALGRIND"/bin
 450        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 451        do
 452                make_valgrind_symlink $file
 453        done
 454        # special-case the mergetools loadables
 455        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 456        OLDIFS=$IFS
 457        IFS=:
 458        for path in $PATH
 459        do
 460                ls "$path"/git-* 2> /dev/null |
 461                while read file
 462                do
 463                        make_valgrind_symlink "$file"
 464                done
 465        done
 466        IFS=$OLDIFS
 467        PATH=$GIT_VALGRIND/bin:$PATH
 468        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 469        export GIT_VALGRIND
 470elif test -n "$GIT_TEST_INSTALLED" ; then
 471        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 472        error "Cannot run git from $GIT_TEST_INSTALLED."
 473        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 474        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 475else # normal case, use ../bin-wrappers only unless $with_dashes:
 476        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 477        if ! test -x "$git_bin_dir/git" ; then
 478                if test -z "$with_dashes" ; then
 479                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 480                fi
 481                with_dashes=t
 482        fi
 483        PATH="$git_bin_dir:$PATH"
 484        GIT_EXEC_PATH=$GIT_BUILD_DIR
 485        if test -n "$with_dashes" ; then
 486                PATH="$GIT_BUILD_DIR:$PATH"
 487        fi
 488fi
 489GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 490unset GIT_CONFIG
 491GIT_CONFIG_NOSYSTEM=1
 492GIT_ATTR_NOSYSTEM=1
 493export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 494
 495. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 496
 497export PERL_PATH
 498
 499if test -z "$GIT_TEST_CMP"
 500then
 501        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 502        then
 503                GIT_TEST_CMP="$DIFF -c"
 504        else
 505                GIT_TEST_CMP="$DIFF -u"
 506        fi
 507fi
 508
 509GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 510export GITPERLLIB
 511test -d "$GIT_BUILD_DIR"/templates/blt || {
 512        error "You haven't built things yet, have you?"
 513}
 514
 515if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 516then
 517        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 518        export GITPYTHONLIB
 519        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 520                error "You haven't built git_remote_helpers yet, have you?"
 521        }
 522fi
 523
 524if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 525        echo >&2 'You need to build test-chmtime:'
 526        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 527        exit 1
 528fi
 529
 530# Test repository
 531test="trash directory.$(basename "$0" .sh)"
 532test -n "$root" && test="$root/$test"
 533case "$test" in
 534/*) TRASH_DIRECTORY="$test" ;;
 535 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
 536esac
 537test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 538rm -fr "$test" || {
 539        GIT_EXIT_OK=t
 540        echo >&5 "FATAL: Cannot prepare test area"
 541        exit 1
 542}
 543
 544HOME="$TRASH_DIRECTORY"
 545export HOME
 546
 547if test -z "$TEST_NO_CREATE_REPO"; then
 548        test_create_repo "$test"
 549else
 550        mkdir -p "$test"
 551fi
 552# Use -P to resolve symlinks in our working directory so that the cwd
 553# in subprocesses like git equals our $PWD (for pathname comparisons).
 554cd -P "$test" || exit 1
 555
 556this_test=${0##*/}
 557this_test=${this_test%%-*}
 558for skp in $GIT_SKIP_TESTS
 559do
 560        case "$this_test" in
 561        $skp)
 562                say_color skip >&3 "skipping test $this_test altogether"
 563                skip_all="skip all tests in $this_test"
 564                test_done
 565        esac
 566done
 567
 568# Provide an implementation of the 'yes' utility
 569yes () {
 570        if test $# = 0
 571        then
 572                y=y
 573        else
 574                y="$*"
 575        fi
 576
 577        while echo "$y"
 578        do
 579                :
 580        done
 581}
 582
 583# Fix some commands on Windows
 584case $(uname -s) in
 585*MINGW*)
 586        # Windows has its own (incompatible) sort and find
 587        sort () {
 588                /usr/bin/sort "$@"
 589        }
 590        find () {
 591                /usr/bin/find "$@"
 592        }
 593        sum () {
 594                md5sum "$@"
 595        }
 596        # git sees Windows-style pwd
 597        pwd () {
 598                builtin pwd -W
 599        }
 600        # no POSIX permissions
 601        # backslashes in pathspec are converted to '/'
 602        # exec does not inherit the PID
 603        test_set_prereq MINGW
 604        test_set_prereq SED_STRIPS_CR
 605        ;;
 606*CYGWIN*)
 607        test_set_prereq POSIXPERM
 608        test_set_prereq EXECKEEPSPID
 609        test_set_prereq NOT_MINGW
 610        test_set_prereq SED_STRIPS_CR
 611        ;;
 612*)
 613        test_set_prereq POSIXPERM
 614        test_set_prereq BSLASHPSPEC
 615        test_set_prereq EXECKEEPSPID
 616        test_set_prereq NOT_MINGW
 617        ;;
 618esac
 619
 620( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 621test -z "$NO_PERL" && test_set_prereq PERL
 622test -z "$NO_PYTHON" && test_set_prereq PYTHON
 623test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 624test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 625
 626# Can we rely on git's output in the C locale?
 627if test -n "$GETTEXT_POISON"
 628then
 629        GIT_GETTEXT_POISON=YesPlease
 630        export GIT_GETTEXT_POISON
 631        test_set_prereq GETTEXT_POISON
 632else
 633        test_set_prereq C_LOCALE_OUTPUT
 634fi
 635
 636# Use this instead of test_cmp to compare files that contain expected and
 637# actual output from git commands that can be translated.  When running
 638# under GETTEXT_POISON this pretends that the command produced expected
 639# results.
 640test_i18ncmp () {
 641        test -n "$GETTEXT_POISON" || test_cmp "$@"
 642}
 643
 644# Use this instead of "grep expected-string actual" to see if the
 645# output from a git command that can be translated either contains an
 646# expected string, or does not contain an unwanted one.  When running
 647# under GETTEXT_POISON this pretends that the command produced expected
 648# results.
 649test_i18ngrep () {
 650        if test -n "$GETTEXT_POISON"
 651        then
 652            : # pretend success
 653        elif test "x!" = "x$1"
 654        then
 655                shift
 656                ! grep "$@"
 657        else
 658                grep "$@"
 659        fi
 660}
 661
 662# test whether the filesystem supports symbolic links
 663ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 664rm -f y
 665
 666# When the tests are run as root, permission tests will report that
 667# things are writable when they shouldn't be.
 668test -w / || test_set_prereq SANITY